<?php
// Local Synchro
// (c) 2007 By Kim Haskell
// www.scriptol.com
include_once("path.php");
include_once("dirlist.php");
$DISPLAY=false;
$VERBOSE=false;
function filecompare($a,$b)
{
   $x=array();
   $y=array();
   $x=file($a);
   $y=file($b);
   return $x ==$y;
}

function filecopy($a,$b)
{
   global $DISPLAY;
   global $VERBOSE;
   if($DISPLAY||$VERBOSE)
   {
      echo $a, " ", "copied in", " ", $b, "\n";
      if($DISPLAY===true)
      {
         return;
      }
   }
   copy($a,$b);
   return;
}

function identical($a,$b)
{
   if(!file_exists($b))
   {
      return false;
   }
   if(filesize($a)!=filesize($b))
   {
      return false;
   }
   return filecompare($a,$b);
}

function synchro($source,$sync)
{
   $dlist=new DirList();
   $content=$dlist->getList($source);
   $a="";
   $b="";
   $c="";
   $any=false;
   if(!file_exists($sync))
   {
      global $VERBOSE;
      global $DISPLAY;
      if($VERBOSE||$DISPLAY)
      {
         echo "CREATED $sync", "\n";
      }
      if(!$DISPLAY)
      {
         mkdir($sync);
      }
      $any=true;
   }
   if(empty($content))
   {
      return;
   }
   reset($content);
   do
   {
      $name= current($content);
      $a=Path::merge($source,$name);
      global $DISPLAY;
      global $VERBOSE;
      if($DISPLAY||$VERBOSE)
      {
         echo "Processing $a", "\n";
      }
      if(filetype($a)==="file")
      {
         $b=Path::merge($sync,$name);
         if($any===true)
         {
            filecopy($a,$b);
            continue;
         }
         if(identical($a,$b)===false)
         {
            filecopy($a,$b);
         }
      }
   }
   while(!(next($content) === false));

   reset($content);
   do
   {
      $name= current($content);
      $a=Path::merge($source,$name);
      if(filetype($a)==="dir")
      {
         synchro($a,Path::merge($sync,$name));
      }
   }
   while(!(next($content) === false));

   return;
}

function usage()
{
   echo "\n";
   echo "Local Synchro", "\n";
   echo "--------------", "\n";
   echo "Syntax:", "\n";
   echo "  synchro [-d] sourcedir syncdir", "\n";
   echo "Options:", "\n";
   echo "  -d display only, do nothing.", "\n";
   echo "  -v verbose, display more infos.", "\n";
   echo "Arguments:", "\n";
   echo "  1 sourcedir: a directory to backup", "\n";
   echo "  2 syncdir: must be synchronized with the source", "\n";
   exit(0);
   return;
}

function main($argc,$argv)
{
   if($argc<4)
   {
      usage();
   }
   $source="";
   $diff="";
   $sync="";
   $_I1= array_slice($argv,1);
   do
   {
      $opt= current($_I1);
      if(substr($opt,0,2)==="-d")
      {
         global $DISPLAY;
         $DISPLAY=true;
         continue;
      }
      if(substr($opt,0,2)==="-v")
      {
         global $VERBOSE;
         $VERBOSE=true;
         continue;
      }
      if($opt{0}==="-")
      {
         usage();
      }
      if($source ==false)
      {
         $source=$opt;
      }
      else
      {
         if($sync ==false)
         {
            $sync=$opt;
         }
         else
         {
            usage();
         }
      }
   }
   while(!(next($_I1) === false));

   echo "Synchronizing from $source to $sync", "\n";
   synchro($source,$sync);
   return 0;
}

main(intVal($argc),$argv);

?>
